# Hulu

## Prerequisites
Download and extracted [TPD-Keys](https://cdm-project.com/Decryption-Tools/TPD-Keys "TPD-Keys")

Working CDM

[EME Logger Script](https://greasyfork.org/en/scripts/373903-eme-logger "EME Logger Script") (installed on [Tampermonkey](https://www.tampermonkey.net/ "Tampermonkey") add-on) will give you init data. That's your PSSH. This can be found on Developer Tools (ctrl + shift + c) > Console, in the filter bar search for `MediaKeySession::generateRequest` you will find Init Data.

## Instructions

### Obtaining Hulu decryption keys.

1) Login to your Hulu account. (ad and ad-free supported)

2) Go to the title you want to decrypt.

3) Start playing the content you want to decrypt.

4) Open web devoloper tools (ctrl+shift+c) and click on the console tab.

5) Refresh the page and play the content again.

6) In the filter bar search for `MediaKeySession::generateRequest` and you should see a field called `Init Data` appear, in that field is your pssh

Save this somewhere safe.

7) find the `License URL` in Hulu this can be found using devoloper tools (ctrl+shift+c) and clicking on the network tab, then searching for `method:POST widevine` in the filter bar.

7a) Right click on the oldest (should be the only, but if not, top most) result, select `Copy URL` and save this somewhere safe

7b) Navigate to your `TPD-keys` directory via command prompt / terminal.

8) Run with `python tpd-keys.py`.

8b) select option 1 for `Generic without any headers`

9) Insert the `pssh`.

10) Insert the `License URL`

11) Select proxy if wanted.

12) You should have an output of all the available keys for content.